﻿#nullable disable

using System.ComponentModel.DataAnnotations;
using System.ComponentModel.DataAnnotations.Schema;

namespace AdoNetWrapperSamples.CustomValidation.EntityClasses;

[Table("Customer", Schema = "SalesLT")]
public partial class Customer {
  [Key]
  [DatabaseGenerated(DatabaseGeneratedOption.Identity)]
  public int CustomerID { get; set; }
  public string Title { get; set; }
  public string FirstName { get; set; }
  public string MiddleName { get; set; }
  public string LastName { get; set; }
  public string CompanyName { get; set; }
  public string PasswordHash { get; set; }
  public string PasswordSalt { get; set; }
  public Guid Rowguid { get; set; }
  public DateTime ModifiedDate { get; set; }

  public override string ToString() {
    return $"{LastName}, {FirstName} ({CustomerID})";
  }
}
